#define __KERNEL__


/* Saint Michael, Linux Kernel Module.
 * Verions: 0.03
 *
 * June 1, 2001
 *
 *
 *    Copyright (C) 2001  Timothy Lalwess (lawless@netdoor.com)
 *
 *    This program is free software; you can redistribute it and/or
 *    modify it under the terms of the GNU General Public License as
 *    published by the Free Software Foundation; either version 2 of
 *    the License, or (at your option) any later version.
 *
 *    This program is distributed in the hope that it will be
 *    useful, but WITHOUT ANY WARRANTY; without even the implied
 *    warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
 *    PURPOSE.  See the GNU General Public License for more details.
 *
 *    You should have received a copy of the GNU General Public
 *    License along with this program; if not, write to the Free
 *    Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139,
 *    USA.
 *      
 *
 * 
 */

 
#include <linux/sys.h>
#include <linux/module.h>
#include <linux/kernel.h>
#include <linux/errno.h>
#include <linux/string.h>
#include <linux/smp.h>
#include <linux/slab.h>
#include <asm/unistd.h>
#include <asm/current.h>
#include <sys/syscall.h>
#include <asm/errno.h>
#include "StMichael_lkm.h"
#include "StMichael_string_util.h"


int
sm_delete_module (const char *name)
{
   int delete_module_return;


   if (name != NULL && *name != '\0')
   {
   if ( ! sm_strncmp(name,"StMichael", 12) )
      {
         sm_print("(STMICHAEL) Attempt To Remove StMichael Detected.\n");
         return -EBUSY;
      }

   if ( ! sm_strncmp(name,"+",1) )
      {
        sm_print("(STMICHAEL) Checking Name 2.\n");
        sm_print("STMICHAEL) Attempt to Remove Protected Module Detected.\n");
        return -EBUSY;
      }
    }

   delete_module_return = (*orig_delete_module)(name);
   
  /* 
     Verify that the syscall table is the same. 
     If its changed then respond 

     We could probably make this a function in itself, but
     why spend the extra time making a call?

   */

#ifdef USE_CHECKSUM
   sm_check_dependency_integrity();
#endif

   sm_check_sys_call_integrity();

  return delete_module_return;
}

