#define __KERNEL__

/* Saint Michael, Linux Kernel Module.
 * Verions: 0.03
 *
 * June 1, 2001
 *
 *
 *    Copyright (C) 2001  Timothy Lalwess (lawless@netdoor.com)
 *
 *    This program is free software; you can redistribute it and/or
 *    modify it under the terms of the GNU General Public License as
 *    published by the Free Software Foundation; either version 2 of
 *    the License, or (at your option) any later version.
 *
 *    This program is distributed in the hope that it will be
 *    useful, but WITHOUT ANY WARRANTY; without even the implied
 *    warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
 *    PURPOSE.  See the GNU General Public License for more details.
 *
 *    You should have received a copy of the GNU General Public
 *    License along with this program; if not, write to the Free
 *    Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139,
 *    USA.
 *      
 *
 * 
 */

#include <linux/sys.h>
#include <linux/sched.h>
#include <linux/module.h>
#include <linux/kernel.h>
#include <asm/uaccess.h>
#include <linux/errno.h>
#include <linux/string.h>
#include <asm/segment.h>
#include <asm/unistd.h>
#include <linux/mm.h>
#include <linux/smp.h>
#include <linux/signal.h>
#include <linux/slab.h>
#include <asm/unistd.h>
#include <asm/current.h>
#include <sys/syscall.h>
#include <asm/errno.h>
#include <asm/ptrace.h>
#include <asm/pgtable.h>
#include <linux/timer.h>
#include "StMichael_lkm.h"
#include "StMichael_timer.h"
#include "StMichael_string_util.h"

timer_t sm_timer;

void sm_timer_init(void)
{
    sm_memset(&sm_timer,0,sizeof(timer_t));
    init_timer(&sm_timer);
    sm_timer.expires = jiffies + SM_TIMEOUT;
    sm_timer.function = sm_timer_handler;
    add_timer(&sm_timer);
}

void sm_timer_handler(unsigned long arg)
{
    del_timer(&sm_timer);


#ifdef USE_CHECKSUM
   sm_check_dependency_integrity();
#endif

   sm_check_sys_call_integrity();

    init_timer(&sm_timer);
    sm_timer.expires = jiffies + SM_TIMEOUT;
    sm_timer.function = sm_timer_handler;
    add_timer(&sm_timer);
}

void sm_timer_remove(void)
{
    del_timer(&sm_timer);
    sm_memset(&sm_timer,0,sizeof(sm_timer));
}
